LeetCode热题100--70. 爬楼梯--简单

题目

假设你正在爬楼梯。需要 n 阶你才能到达楼顶。

每次你可以爬 1 或 2 个台阶。你有多少种不同的方法可以爬到楼顶呢?

示例 1:

输入:n = 2

输出:2

解释:有两种方法可以爬到楼顶。

  1. 1 阶 + 1 阶
  2. 2 阶

示例 2:

输入:n = 3

输出:3

解释:有三种方法可以爬到楼顶。

  1. 1 阶 + 1 阶 + 1 阶
  2. 1 阶 + 2 阶
  3. 2 阶 + 1 阶

题解

java 复制代码
class Solution {
    public int climbStairs(int n) {
        int[] dp = new int[n + 1];
        dp[0] = 1;
        dp[1] = 1;
        for(int i = 2; i <= n; i++) {
            dp[i] = dp[i - 1] + dp[i - 2];
        }
        return dp[n];
    }
}

解析

出自:画解算法:70. 爬楼梯

java 复制代码
class Solution  {   //定义一个新的解决方案类
    public int climbStairs(int n)  {   //通过一个整数输入参数n来爬楼梯
        int[] dp = new int[n + 1];     //初始化以存储子问题结果的DP数组。dp将用于存储不同的爬楼梯情况次数。我们需要这个数组来存储从0到'n'的每个索引上可能的爬楼梯方式数量
       dp[0] = 1;                  //有一种方式可以通过不迈步子(即在起点)到达终点。因此dp[0]初始化为1
       dp[1] = 1;                  //有两种方式可以通过一级台阶到达终点,每次迈一步或踏两步到第二级台阶(没有台阶的长度可供迈步)- 所以dp[1]也被初始化为1
       for(int i = 2; i <= n; i++) {   //从左到右开始计算不同步数所需的方式数量。在循环中'i'表示当前台阶的长度,我们基于先前状态dp[i - 1]和dp[i - 2]来通过迈一级或两级台阶计算可能的爬楼梯方式数量
          dp[i] = dp[i - 1] + dp[i - 2]; //每一步我们从最后的两个步数状态获取可能的方式,并将它们相加。所以在dp[i]位置上最终保存了所有过去组合后的总方式数量
			}
        return dp[n];
    }
}
相关推荐
罗湖老棍子1 小时前
【例 1】Sightseeing Trip(信息学奥赛一本通- P1494)(洛谷-P10927)
数据结构·算法·图论·最短路·floyd·最小环
文丑颜不良啊1 小时前
LeetCode201~225题目解析
java·leetcode
stsdddd3 小时前
YOLO算法建筑工地安全帽目标检测数据集16881张:标注核对笔记
算法·yolo·目标检测
CV爱数码4 小时前
论文精读|Learned Primal-Dual:把原始–对偶算法展开成网络
图像处理·算法·计算机视觉·ct·重建·断层扫描
yuniko-n4 小时前
【算法】约瑟夫环问题
java·算法
l1t5 小时前
测试DuckDB v2.1.0-alpha49002的bignum乘法
数据库·sql·算法·duckdb
Nil2085 小时前
LeetCode 283移动零
数据结构·算法·leetcode
CQU_JIAKE5 小时前
10.18【A】
算法
学顶教育5 小时前
学顶教育:公务员面试常见问题!
面试·职场和发展
LMT流氓兔5 小时前
第五单元——第4课:给工具参数加校验
java·前端·算法·ai·langchain